#ifndef DRAW_H_INCLUDED
#define DRAW_H_INCLUDED
#include "maze.h"

extern byte image_buffer[SCREEN_HEIGHT][SCREEN_WIDTH];

int check_zbuffer_consistency();

#ifdef comment
/* argumenty funkcji draw_..._wall */
typedef void (*draw_wall_function)(
		float,		/* wsprzdna X  */
		float,		/* i Z pierwszego (a) wierzchoka ciany */
		float,		/* wsprzdna X */
		float,		/* i Z drugiego (b) wierzchoka ciany */
		const Edge*,	/* parametry ciany */
		
		/* wsprzdne parametryczne wierchokw a i b caa ciana */
		/* rozciga si od 0 do 1 */
		float,		/* wsprzdna dla a */
		float		/* wsprzdna dla b */
	);
#endif

/* Funkcja inicjuje bufor Z; ze wzgldu na charakter sceny 3D bufor ten jest */
/* jednowymiarowy (ciana blisza zawsze ma wiksz wysoko ni ciana */
/* bardziej oddalona, "relacja" przysaniania nie zaley wsp. Y). */
void init_zbuffer();

/* Funkcja zwraca 1 gdy cay bufor Z jest zapeniony -- nie ma wwczas sensu */
/* kontynuowa wywietlanie cian */
int zbuffer_full();

/* Funkcja rysujca pask cian; kolor ciany zaley od odlegoci od */
/* obserwatora. */
void draw_flat_wall(
	float XA, float ZA, 
	float XB, float ZB, 
	const Edge *E,
	float dummy1, float dummy2);

/* Funkcja rysujca przezroczyst cian. */
void draw_glass_wall(
	float XA, float ZA, 
	float XB, float ZB, 
	const Edge *E,
	float dummy1, float dummy2);

/* Funkcja rysujca cieniowan cian; cieniowanie na podstawie odlegoci */
/* wierzchokw od obserwatora. */
void draw_shaded_wall(
	float XA, float ZA, 
	float XB, float ZB, 
	const Edge *E,
	float dummy1, float dummy2);

/* Funkcja prekalkuluje pewne rzeczy potrzebne do teksturowania
i adresowania ekranu */
void prepare_lookups();

/* Funkcja rysujca teksturowan cian */
void draw_textured_wall(
	float XA, float ZA, 
	float XB, float ZB, 
	const Edge *E,
	float u0, float u1);

#endif
/*
vim ts=8
*/
